
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

    <title>Upgrading to Varnish 5.0 &#8212; Varnish version 6.0.11 documentation</title>
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/classic.css" />
    
    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Changes in Varnish 4.1" href="changes-4.1.html" />
    <link rel="prev" title="Changes in Varnish 5.0" href="changes-5.0.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="changes-4.1.html" title="Changes in Varnish 4.1"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="changes-5.0.html" title="Changes in Varnish 5.0"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">What’s new / Upgrading</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Upgrading to Varnish 5.0</a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <section id="upgrading-to-varnish-5-0">
<span id="whatsnew-upgrading-5-0"></span><h1>Upgrading to Varnish 5.0<a class="headerlink" href="#upgrading-to-varnish-5-0" title="Permalink to this headline">¶</a></h1>
<section id="changes-to-vcl">
<h2>Changes to VCL<a class="headerlink" href="#changes-to-vcl" title="Permalink to this headline">¶</a></h2>
<ul>
<li><p>All VCL Objects should now be defined before used</p>
<ul>
<li><p>in particular, this is now required for ACLs. The error message
for ACLs being used before being defined is confusing - see PR #2021:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="n">Name</span> <span class="o">&lt;</span><span class="n">acl</span><span class="o">&gt;</span> <span class="ow">is</span> <span class="n">a</span> <span class="n">reserved</span> <span class="n">name</span>
</pre></div>
</div>
</li>
</ul>
</li>
<li><p>VCL names are restricted to alphanumeric characters, dashes (-) and
underscores (_).  In addition, the first character should be alphabetic.
That is, the name should match “[A-Za-z][A-Za-z0-9_-]*”.</p></li>
<li><p>Like strings, backends and integers can now be used as boolean
expressions in if statements.  See <code class="docutils literal notranslate"><span class="pre">vcl(7)</span></code> for details.</p></li>
<li><p>Add support to perform matches in assignments, obtaining a boolean
as result:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="nb">set</span> <span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">foo</span> <span class="o">=</span> <span class="n">req</span><span class="o">.</span><span class="n">http</span><span class="o">.</span><span class="n">bar</span> <span class="o">~</span> <span class="s2">&quot;bar&quot;</span><span class="p">;</span>
</pre></div>
</div>
</li>
<li><p>Returned values from functions and methods’ calls can be thrown away.</p></li>
</ul>
<section id="backends">
<h3>backends<a class="headerlink" href="#backends" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added support for the PROXY protocol via <code class="docutils literal notranslate"><span class="pre">.proxy_header</span></code> attribute.
Possible values are 1 and 2, corresponding to the PROXY protocol
version 1 and 2, respectively.</p></li>
</ul>
</section>
<section id="vcl-recv">
<h3>vcl_recv<a class="headerlink" href="#vcl-recv" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added <code class="docutils literal notranslate"><span class="pre">return</span> <span class="pre">(vcl(label))</span></code> to switch to the VCL labelled <cite>label</cite>.</p></li>
<li><p>The <code class="docutils literal notranslate"><span class="pre">rollback</span></code> function has been retired.</p></li>
</ul>
</section>
<section id="vcl-hit">
<h3>vcl_hit<a class="headerlink" href="#vcl-hit" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Replace <code class="docutils literal notranslate"><span class="pre">return</span> <span class="pre">(fetch)</span></code> with <code class="docutils literal notranslate"><span class="pre">return</span> <span class="pre">(miss)</span></code>.</p></li>
</ul>
</section>
<section id="vcl-backend">
<h3>vcl_backend_*<a class="headerlink" href="#vcl-backend" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added read access to <code class="docutils literal notranslate"><span class="pre">remote.ip</span></code>, <code class="docutils literal notranslate"><span class="pre">client.ip</span></code>, <code class="docutils literal notranslate"><span class="pre">local.ip</span></code> and
<code class="docutils literal notranslate"><span class="pre">server.ip</span></code>.</p></li>
</ul>
</section>
<section id="vcl-backend-fetch">
<h3>vcl_backend_fetch<a class="headerlink" href="#vcl-backend-fetch" title="Permalink to this headline">¶</a></h3>
<ul>
<li><p>Added write access to <code class="docutils literal notranslate"><span class="pre">bereq.body</span></code>, the request body. Only <code class="docutils literal notranslate"><span class="pre">unset</span></code>
is supported at this time.</p></li>
<li><p>We now send request bodies by default (see
<a class="reference internal" href="changes-5.0.html#whatsnew-changes-5-0-reqbody"><span class="std std-ref">Request Body sent always / “cacheable POST”</span></a>). To keep the previous behaviour
add the following code before any <code class="docutils literal notranslate"><span class="pre">return</span> <span class="pre">(..)</span></code> statement in this
subroutine:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="k">if</span> <span class="p">(</span><span class="n">bereq</span><span class="o">.</span><span class="n">method</span> <span class="o">==</span> <span class="s2">&quot;GET&quot;</span><span class="p">)</span> <span class="p">{</span>
    <span class="n">unset</span> <span class="n">bereq</span><span class="o">.</span><span class="n">body</span><span class="p">;</span>
<span class="p">}</span>
</pre></div>
</div>
</li>
</ul>
</section>
<section id="vcl-backend-error">
<h3>vcl_backend_error<a class="headerlink" href="#vcl-backend-error" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added write access to <code class="docutils literal notranslate"><span class="pre">beresp.body</span></code>, the response body. This may
replace <code class="docutils literal notranslate"><span class="pre">synthetic()</span></code> in future releases.</p></li>
</ul>
</section>
<section id="vcl-deliver">
<h3>vcl_deliver<a class="headerlink" href="#vcl-deliver" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added read access to <code class="docutils literal notranslate"><span class="pre">obj.ttl</span></code>, <code class="docutils literal notranslate"><span class="pre">obj.age</span></code>, <code class="docutils literal notranslate"><span class="pre">obj.grace</span></code> and
<code class="docutils literal notranslate"><span class="pre">obj.keep</span></code>.</p></li>
</ul>
</section>
<section id="vcl-synth">
<h3>vcl_synth<a class="headerlink" href="#vcl-synth" title="Permalink to this headline">¶</a></h3>
<ul class="simple">
<li><p>Added write access to <code class="docutils literal notranslate"><span class="pre">resp.body</span></code>, the response body. This may replace
<code class="docutils literal notranslate"><span class="pre">synthetic()</span></code> in future releases.</p></li>
</ul>
</section>
</section>
<section id="management-interface">
<h2>Management interface<a class="headerlink" href="#management-interface" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>To disable CLI authentication use <code class="docutils literal notranslate"><span class="pre">-S</span> <span class="pre">none</span></code>.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">n_waitinglist</span></code> statistic removed.</p></li>
</ul>
</section>
<section id="changes-to-parameters">
<h2>Changes to parameters<a class="headerlink" href="#changes-to-parameters" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p>Added <code class="docutils literal notranslate"><span class="pre">ban_lurker_holdoff</span></code>.</p></li>
<li><p>Removed <code class="docutils literal notranslate"><span class="pre">session_max</span></code>.  This parameter actually had no effect since
4.0 but might come back in a future release.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">vcl_path</span></code> is now a colon-separated list of directories, replacing
<code class="docutils literal notranslate"><span class="pre">vcl_dir</span></code>.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">vmod_path</span></code> is now a colon-separated list of directories, replacing
<code class="docutils literal notranslate"><span class="pre">vmod_dir</span></code>.</p></li>
</ul>
</section>
<section id="other-changes">
<h2>Other changes<a class="headerlink" href="#other-changes" title="Permalink to this headline">¶</a></h2>
<ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">varnishstat(1)</span></code> -f option accepts a <code class="docutils literal notranslate"><span class="pre">glob(7)</span></code> pattern.</p></li>
<li><p>Cache-Control and Expires headers for uncacheable requests (i.e. passes)
will not be parsed.  As a result, the RFC variant of the TTL VSL tag
is no longer logged.</p></li>
</ul>
</section>
</section>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">Upgrading to Varnish 5.0</a><ul>
<li><a class="reference internal" href="#changes-to-vcl">Changes to VCL</a><ul>
<li><a class="reference internal" href="#backends">backends</a></li>
<li><a class="reference internal" href="#vcl-recv">vcl_recv</a></li>
<li><a class="reference internal" href="#vcl-hit">vcl_hit</a></li>
<li><a class="reference internal" href="#vcl-backend">vcl_backend_*</a></li>
<li><a class="reference internal" href="#vcl-backend-fetch">vcl_backend_fetch</a></li>
<li><a class="reference internal" href="#vcl-backend-error">vcl_backend_error</a></li>
<li><a class="reference internal" href="#vcl-deliver">vcl_deliver</a></li>
<li><a class="reference internal" href="#vcl-synth">vcl_synth</a></li>
</ul>
</li>
<li><a class="reference internal" href="#management-interface">Management interface</a></li>
<li><a class="reference internal" href="#changes-to-parameters">Changes to parameters</a></li>
<li><a class="reference internal" href="#other-changes">Other changes</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="changes-5.0.html"
                        title="previous chapter">Changes in Varnish 5.0</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="changes-4.1.html"
                        title="next chapter">Changes in Varnish 4.1</a></p>
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="../_sources/whats-new/upgrading-5.0.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="changes-4.1.html" title="Changes in Varnish 4.1"
             >next</a> |</li>
        <li class="right" >
          <a href="changes-5.0.html" title="Changes in Varnish 5.0"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../index.html">Varnish version 6.0.11 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="index.html" >What’s new / Upgrading</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href="">Upgrading to Varnish 5.0</a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2010-2014, Varnish Software AS.
      Created using <a href="https://www.sphinx-doc.org/">Sphinx</a> 4.3.2.
    </div>
  </body>
</html>